git-am.shon commit Merge branch 'jc/maint-smart-http-race-upload-pack' (2f5cb6a)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25C=              pass it through git-apply
  26p=              pass it through git-apply
  27patch-format=   format the patch(es) are in
  28reject          pass it through git-apply
  29resolvemsg=     override error message when patch failure occurs
  30continue        continue applying patches after resolving a conflict
  31r,resolved      synonyms for --continue
  32skip            skip the current patch
  33abort           restore the original branch and abort the patching operation.
  34committer-date-is-author-date    lie about committer date
  35ignore-date     use current timestamp for author date
  36rerere-autoupdate update the index with reused conflict resolution if possible
  37rebasing*       (internal use for git-rebase)"
  38
  39. git-sh-setup
  40. git-sh-i18n
  41prefix=$(git rev-parse --show-prefix)
  42set_reflog_action am
  43require_work_tree
  44cd_to_toplevel
  45
  46git var GIT_COMMITTER_IDENT >/dev/null ||
  47        die "$(gettext "You need to set your committer info first")"
  48
  49if git rev-parse --verify -q HEAD >/dev/null
  50then
  51        HAS_HEAD=yes
  52else
  53        HAS_HEAD=
  54fi
  55
  56cmdline="git am"
  57if test '' != "$interactive"
  58then
  59        cmdline="$cmdline -i"
  60fi
  61if test '' != "$threeway"
  62then
  63        cmdline="$cmdline -3"
  64fi
  65
  66sq () {
  67        git rev-parse --sq-quote "$@"
  68}
  69
  70stop_here () {
  71    echo "$1" >"$dotest/next"
  72    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  73    exit 1
  74}
  75
  76safe_to_abort () {
  77        if test -f "$dotest/dirtyindex"
  78        then
  79                return 1
  80        fi
  81
  82        if ! test -s "$dotest/abort-safety"
  83        then
  84                return 0
  85        fi
  86
  87        abort_safety=$(cat "$dotest/abort-safety")
  88        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  89        then
  90                return 0
  91        fi
  92        (
  93                gettext "You seem to have moved HEAD since the last 'am' failure.
  94Not rewinding to ORIG_HEAD" &&
  95                echo
  96        ) >&2
  97        return 1
  98}
  99
 100stop_here_user_resolve () {
 101    if [ -n "$resolvemsg" ]; then
 102            printf '%s\n' "$resolvemsg"
 103            stop_here $1
 104    fi
 105    eval_gettext "When you have resolved this problem run \"\$cmdline --resolved\".
 106If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 107To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
 108
 109    stop_here $1
 110}
 111
 112go_next () {
 113        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 114                "$dotest/patch" "$dotest/info"
 115        echo "$next" >"$dotest/next"
 116        this=$next
 117}
 118
 119cannot_fallback () {
 120        echo "$1"
 121        gettext "Cannot fall back to three-way merge."; echo
 122        exit 1
 123}
 124
 125fall_back_3way () {
 126    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 127
 128    rm -fr "$dotest"/patch-merge-*
 129    mkdir "$dotest/patch-merge-tmp-dir"
 130
 131    # First see if the patch records the index info that we can use.
 132    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 133        "$dotest/patch" &&
 134    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 135    git write-tree >"$dotest/patch-merge-base+" ||
 136    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 137
 138    say Using index info to reconstruct a base tree...
 139    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 140        git apply --cached <"$dotest/patch"
 141    then
 142        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 143        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 144    else
 145        cannot_fallback "$(gettext "Did you hand edit your patch?
 146It does not apply to blobs recorded in its index.")"
 147    fi
 148
 149    test -f "$dotest/patch-merge-index" &&
 150    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 151    orig_tree=$(cat "$dotest/patch-merge-base") &&
 152    rm -fr "$dotest"/patch-merge-* || exit 1
 153
 154    say "$(gettext "Falling back to patching base and 3-way merge...")"
 155
 156    # This is not so wrong.  Depending on which base we picked,
 157    # orig_tree may be wildly different from ours, but his_tree
 158    # has the same set of wildly different changes in parts the
 159    # patch did not touch, so recursive ends up canceling them,
 160    # saying that we reverted all those changes.
 161
 162    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 163    export GITHEAD_$his_tree
 164    if test -n "$GIT_QUIET"
 165    then
 166            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 167    fi
 168    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 169            git rerere $allow_rerere_autoupdate
 170            echo Failed to merge in the changes.
 171            exit 1
 172    }
 173    unset GITHEAD_$his_tree
 174}
 175
 176clean_abort () {
 177        test $# = 0 || echo >&2 "$@"
 178        rm -fr "$dotest"
 179        exit 1
 180}
 181
 182patch_format=
 183
 184check_patch_format () {
 185        # early return if patch_format was set from the command line
 186        if test -n "$patch_format"
 187        then
 188                return 0
 189        fi
 190
 191        # we default to mbox format if input is from stdin and for
 192        # directories
 193        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 194        then
 195                patch_format=mbox
 196                return 0
 197        fi
 198
 199        # otherwise, check the first few lines of the first patch to try
 200        # to detect its format
 201        {
 202                read l1
 203                read l2
 204                read l3
 205                case "$l1" in
 206                "From "* | "From: "*)
 207                        patch_format=mbox
 208                        ;;
 209                '# This series applies on GIT commit'*)
 210                        patch_format=stgit-series
 211                        ;;
 212                "# HG changeset patch")
 213                        patch_format=hg
 214                        ;;
 215                *)
 216                        # if the second line is empty and the third is
 217                        # a From, Author or Date entry, this is very
 218                        # likely an StGIT patch
 219                        case "$l2,$l3" in
 220                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 221                                patch_format=stgit
 222                                ;;
 223                        *)
 224                                ;;
 225                        esac
 226                        ;;
 227                esac
 228                if test -z "$patch_format" &&
 229                        test -n "$l1" &&
 230                        test -n "$l2" &&
 231                        test -n "$l3"
 232                then
 233                        # This begins with three non-empty lines.  Is this a
 234                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 235                        # discarding the indented remainder of folded lines,
 236                        # and see if it looks like that they all begin with the
 237                        # header field names...
 238                        tr -d '\015' <"$1" |
 239                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 240                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 241                        patch_format=mbox
 242                fi
 243        } < "$1" || clean_abort
 244}
 245
 246split_patches () {
 247        case "$patch_format" in
 248        mbox)
 249                if test -n "$rebasing" || test t = "$keepcr"
 250                then
 251                    keep_cr=--keep-cr
 252                else
 253                    keep_cr=
 254                fi
 255                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 256                clean_abort
 257                ;;
 258        stgit-series)
 259                if test $# -ne 1
 260                then
 261                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 262                fi
 263                series_dir=`dirname "$1"`
 264                series_file="$1"
 265                shift
 266                {
 267                        set x
 268                        while read filename
 269                        do
 270                                set "$@" "$series_dir/$filename"
 271                        done
 272                        # remove the safety x
 273                        shift
 274                        # remove the arg coming from the first-line comment
 275                        shift
 276                } < "$series_file" || clean_abort
 277                # set the patch format appropriately
 278                patch_format=stgit
 279                # now handle the actual StGIT patches
 280                split_patches "$@"
 281                ;;
 282        stgit)
 283                this=0
 284                for stgit in "$@"
 285                do
 286                        this=`expr "$this" + 1`
 287                        msgnum=`printf "%0${prec}d" $this`
 288                        # Perl version of StGIT parse_patch. The first nonemptyline
 289                        # not starting with Author, From or Date is the
 290                        # subject, and the body starts with the next nonempty
 291                        # line not starting with Author, From or Date
 292                        perl -ne 'BEGIN { $subject = 0 }
 293                                if ($subject > 1) { print ; }
 294                                elsif (/^\s+$/) { next ; }
 295                                elsif (/^Author:/) { print s/Author/From/ ; }
 296                                elsif (/^(From|Date)/) { print ; }
 297                                elsif ($subject) {
 298                                        $subject = 2 ;
 299                                        print "\n" ;
 300                                        print ;
 301                                } else {
 302                                        print "Subject: ", $_ ;
 303                                        $subject = 1;
 304                                }
 305                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 306                done
 307                echo "$this" > "$dotest/last"
 308                this=
 309                msgnum=
 310                ;;
 311        *)
 312                if test -n "$parse_patch" ; then
 313                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 314                else
 315                        clean_abort "$(gettext "Patch format detection failed.")"
 316                fi
 317                ;;
 318        esac
 319}
 320
 321prec=4
 322dotest="$GIT_DIR/rebase-apply"
 323sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 324resolvemsg= resume= scissors= no_inbody_headers=
 325git_apply_opt=
 326committer_date_is_author_date=
 327ignore_date=
 328allow_rerere_autoupdate=
 329
 330if test "$(git config --bool --get am.keepcr)" = true
 331then
 332    keepcr=t
 333fi
 334
 335while test $# != 0
 336do
 337        case "$1" in
 338        -i|--interactive)
 339                interactive=t ;;
 340        -b|--binary)
 341                : ;;
 342        -3|--3way)
 343                threeway=t ;;
 344        -s|--signoff)
 345                sign=t ;;
 346        -u|--utf8)
 347                utf8=t ;; # this is now default
 348        --no-utf8)
 349                utf8= ;;
 350        -k|--keep)
 351                keep=t ;;
 352        -c|--scissors)
 353                scissors=t ;;
 354        --no-scissors)
 355                scissors=f ;;
 356        -r|--resolved|--continue)
 357                resolved=t ;;
 358        --skip)
 359                skip=t ;;
 360        --abort)
 361                abort=t ;;
 362        --rebasing)
 363                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 364        -d|--dotest)
 365                die "$(gettext "-d option is no longer supported.  Do not use.")"
 366                ;;
 367        --resolvemsg)
 368                shift; resolvemsg=$1 ;;
 369        --whitespace|--directory)
 370                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 371        -C|-p)
 372                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 373        --patch-format)
 374                shift ; patch_format="$1" ;;
 375        --reject|--ignore-whitespace|--ignore-space-change)
 376                git_apply_opt="$git_apply_opt $1" ;;
 377        --committer-date-is-author-date)
 378                committer_date_is_author_date=t ;;
 379        --ignore-date)
 380                ignore_date=t ;;
 381        --rerere-autoupdate|--no-rerere-autoupdate)
 382                allow_rerere_autoupdate="$1" ;;
 383        -q|--quiet)
 384                GIT_QUIET=t ;;
 385        --keep-cr)
 386                keepcr=t ;;
 387        --no-keep-cr)
 388                keepcr=f ;;
 389        --)
 390                shift; break ;;
 391        *)
 392                usage ;;
 393        esac
 394        shift
 395done
 396
 397# If the dotest directory exists, but we have finished applying all the
 398# patches in them, clear it out.
 399if test -d "$dotest" &&
 400   last=$(cat "$dotest/last") &&
 401   next=$(cat "$dotest/next") &&
 402   test $# != 0 &&
 403   test "$next" -gt "$last"
 404then
 405   rm -fr "$dotest"
 406fi
 407
 408if test -d "$dotest"
 409then
 410        case "$#,$skip$resolved$abort" in
 411        0,*t*)
 412                # Explicit resume command and we do not have file, so
 413                # we are happy.
 414                : ;;
 415        0,)
 416                # No file input but without resume parameters; catch
 417                # user error to feed us a patch from standard input
 418                # when there is already $dotest.  This is somewhat
 419                # unreliable -- stdin could be /dev/null for example
 420                # and the caller did not intend to feed us a patch but
 421                # wanted to continue unattended.
 422                test -t 0
 423                ;;
 424        *)
 425                false
 426                ;;
 427        esac ||
 428        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 429        resume=yes
 430
 431        case "$skip,$abort" in
 432        t,t)
 433                die "$(gettext "Please make up your mind. --skip or --abort?")"
 434                ;;
 435        t,)
 436                git rerere clear
 437                git read-tree --reset -u HEAD HEAD
 438                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 439                git reset HEAD
 440                git update-ref ORIG_HEAD $orig_head
 441                ;;
 442        ,t)
 443                if test -f "$dotest/rebasing"
 444                then
 445                        exec git rebase --abort
 446                fi
 447                git rerere clear
 448                if safe_to_abort
 449                then
 450                        git read-tree --reset -u HEAD ORIG_HEAD
 451                        git reset ORIG_HEAD
 452                fi
 453                rm -fr "$dotest"
 454                exit ;;
 455        esac
 456        rm -f "$dotest/dirtyindex"
 457else
 458        # Make sure we are not given --skip, --resolved, nor --abort
 459        test "$skip$resolved$abort" = "" ||
 460                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 461
 462        # Start afresh.
 463        mkdir -p "$dotest" || exit
 464
 465        if test -n "$prefix" && test $# != 0
 466        then
 467                first=t
 468                for arg
 469                do
 470                        test -n "$first" && {
 471                                set x
 472                                first=
 473                        }
 474                        if is_absolute_path "$arg"
 475                        then
 476                                set "$@" "$arg"
 477                        else
 478                                set "$@" "$prefix$arg"
 479                        fi
 480                done
 481                shift
 482        fi
 483
 484        check_patch_format "$@"
 485
 486        split_patches "$@"
 487
 488        # -i can and must be given when resuming; everything
 489        # else is kept
 490        echo " $git_apply_opt" >"$dotest/apply-opt"
 491        echo "$threeway" >"$dotest/threeway"
 492        echo "$sign" >"$dotest/sign"
 493        echo "$utf8" >"$dotest/utf8"
 494        echo "$keep" >"$dotest/keep"
 495        echo "$keepcr" >"$dotest/keepcr"
 496        echo "$scissors" >"$dotest/scissors"
 497        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 498        echo "$GIT_QUIET" >"$dotest/quiet"
 499        echo 1 >"$dotest/next"
 500        if test -n "$rebasing"
 501        then
 502                : >"$dotest/rebasing"
 503        else
 504                : >"$dotest/applying"
 505                if test -n "$HAS_HEAD"
 506                then
 507                        git update-ref ORIG_HEAD HEAD
 508                else
 509                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 510                fi
 511        fi
 512fi
 513
 514git update-index -q --refresh
 515
 516case "$resolved" in
 517'')
 518        case "$HAS_HEAD" in
 519        '')
 520                files=$(git ls-files) ;;
 521        ?*)
 522                files=$(git diff-index --cached --name-only HEAD --) ;;
 523        esac || exit
 524        if test "$files"
 525        then
 526                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 527                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 528        fi
 529esac
 530
 531if test "$(cat "$dotest/utf8")" = t
 532then
 533        utf8=-u
 534else
 535        utf8=-n
 536fi
 537if test "$(cat "$dotest/keep")" = t
 538then
 539        keep=-k
 540fi
 541case "$(cat "$dotest/keepcr")" in
 542t)
 543        keepcr=--keep-cr ;;
 544f)
 545        keepcr=--no-keep-cr ;;
 546esac
 547case "$(cat "$dotest/scissors")" in
 548t)
 549        scissors=--scissors ;;
 550f)
 551        scissors=--no-scissors ;;
 552esac
 553if test "$(cat "$dotest/no_inbody_headers")" = t
 554then
 555        no_inbody_headers=--no-inbody-headers
 556else
 557        no_inbody_headers=
 558fi
 559if test "$(cat "$dotest/quiet")" = t
 560then
 561        GIT_QUIET=t
 562fi
 563if test "$(cat "$dotest/threeway")" = t
 564then
 565        threeway=t
 566fi
 567git_apply_opt=$(cat "$dotest/apply-opt")
 568if test "$(cat "$dotest/sign")" = t
 569then
 570        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 571                        s/>.*/>/
 572                        s/^/Signed-off-by: /'
 573                `
 574else
 575        SIGNOFF=
 576fi
 577
 578last=`cat "$dotest/last"`
 579this=`cat "$dotest/next"`
 580if test "$skip" = t
 581then
 582        this=`expr "$this" + 1`
 583        resume=
 584fi
 585
 586while test "$this" -le "$last"
 587do
 588        msgnum=`printf "%0${prec}d" $this`
 589        next=`expr "$this" + 1`
 590        test -f "$dotest/$msgnum" || {
 591                resume=
 592                go_next
 593                continue
 594        }
 595
 596        # If we are not resuming, parse and extract the patch information
 597        # into separate files:
 598        #  - info records the authorship and title
 599        #  - msg is the rest of commit log message
 600        #  - patch is the patch body.
 601        #
 602        # When we are resuming, these files are either already prepared
 603        # by the user, or the user can tell us to do so by --resolved flag.
 604        case "$resume" in
 605        '')
 606                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 607                        <"$dotest/$msgnum" >"$dotest/info" ||
 608                        stop_here $this
 609
 610                # skip pine's internal folder data
 611                sane_grep '^Author: Mail System Internal Data$' \
 612                        <"$dotest"/info >/dev/null &&
 613                        go_next && continue
 614
 615                test -s "$dotest/patch" || {
 616                        eval_gettext "Patch is empty.  Was it split wrong?
 617If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 618To restore the original branch and stop patching run \"\$cmdline --abort\"."; echo
 619                        stop_here $this
 620                }
 621                rm -f "$dotest/original-commit" "$dotest/author-script"
 622                if test -f "$dotest/rebasing" &&
 623                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 624                                -e q "$dotest/$msgnum") &&
 625                        test "$(git cat-file -t "$commit")" = commit
 626                then
 627                        git cat-file commit "$commit" |
 628                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 629                        echo "$commit" > "$dotest/original-commit"
 630                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 631                else
 632                        {
 633                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 634                                echo
 635                                cat "$dotest/msg"
 636                        } |
 637                        git stripspace > "$dotest/msg-clean"
 638                fi
 639                ;;
 640        esac
 641
 642        if test -f "$dotest/author-script"
 643        then
 644                eval $(cat "$dotest/author-script")
 645        else
 646                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 647                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 648                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 649        fi
 650
 651        if test -z "$GIT_AUTHOR_EMAIL"
 652        then
 653                gettext "Patch does not have a valid e-mail address."; echo
 654                stop_here $this
 655        fi
 656
 657        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 658
 659        case "$resume" in
 660        '')
 661            if test '' != "$SIGNOFF"
 662            then
 663                LAST_SIGNED_OFF_BY=`
 664                    sed -ne '/^Signed-off-by: /p' \
 665                    "$dotest/msg-clean" |
 666                    sed -ne '$p'
 667                `
 668                ADD_SIGNOFF=`
 669                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 670                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 671                    echo "$SIGNOFF"
 672                }`
 673            else
 674                ADD_SIGNOFF=
 675            fi
 676            {
 677                if test -s "$dotest/msg-clean"
 678                then
 679                        cat "$dotest/msg-clean"
 680                fi
 681                if test '' != "$ADD_SIGNOFF"
 682                then
 683                        echo "$ADD_SIGNOFF"
 684                fi
 685            } >"$dotest/final-commit"
 686            ;;
 687        *)
 688                case "$resolved$interactive" in
 689                tt)
 690                        # This is used only for interactive view option.
 691                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 692                        ;;
 693                esac
 694        esac
 695
 696        resume=
 697        if test "$interactive" = t
 698        then
 699            test -t 0 ||
 700            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 701            action=again
 702            while test "$action" = again
 703            do
 704                gettext "Commit Body is:"; echo
 705                echo "--------------------------"
 706                cat "$dotest/final-commit"
 707                echo "--------------------------"
 708                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 709                # in your translation. The program will only accept English
 710                # input at this point.
 711                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 712                read reply
 713                case "$reply" in
 714                [yY]*) action=yes ;;
 715                [aA]*) action=yes interactive= ;;
 716                [nN]*) action=skip ;;
 717                [eE]*) git_editor "$dotest/final-commit"
 718                       action=again ;;
 719                [vV]*) action=again
 720                       git_pager "$dotest/patch" ;;
 721                *)     action=again ;;
 722                esac
 723            done
 724        else
 725            action=yes
 726        fi
 727
 728        if test -f "$dotest/final-commit"
 729        then
 730                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 731        else
 732                FIRSTLINE=""
 733        fi
 734
 735        if test $action = skip
 736        then
 737                go_next
 738                continue
 739        fi
 740
 741        if test -x "$GIT_DIR"/hooks/applypatch-msg
 742        then
 743                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 744                stop_here $this
 745        fi
 746
 747        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 748
 749        case "$resolved" in
 750        '')
 751                # When we are allowed to fall back to 3-way later, don't give
 752                # false errors during the initial attempt.
 753                squelch=
 754                if test "$threeway" = t
 755                then
 756                        squelch='>/dev/null 2>&1 '
 757                fi
 758                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 759                apply_status=$?
 760                ;;
 761        t)
 762                # Resolved means the user did all the hard work, and
 763                # we do not have to do any patch application.  Just
 764                # trust what the user has in the index file and the
 765                # working tree.
 766                resolved=
 767                git diff-index --quiet --cached HEAD -- && {
 768                        gettext "No changes - did you forget to use 'git add'?
 769If there is nothing left to stage, chances are that something else
 770already introduced the same changes; you might want to skip this patch."; echo
 771                        stop_here_user_resolve $this
 772                }
 773                unmerged=$(git ls-files -u)
 774                if test -n "$unmerged"
 775                then
 776                        gettext "You still have unmerged paths in your index
 777did you forget to use 'git add'?"; echo
 778                        stop_here_user_resolve $this
 779                fi
 780                apply_status=0
 781                git rerere
 782                ;;
 783        esac
 784
 785        if test $apply_status != 0 && test "$threeway" = t
 786        then
 787                if (fall_back_3way)
 788                then
 789                    # Applying the patch to an earlier tree and merging the
 790                    # result may have produced the same tree as ours.
 791                    git diff-index --quiet --cached HEAD -- && {
 792                        say "$(gettext "No changes -- Patch already applied.")"
 793                        go_next
 794                        continue
 795                    }
 796                    # clear apply_status -- we have successfully merged.
 797                    apply_status=0
 798                fi
 799        fi
 800        if test $apply_status != 0
 801        then
 802                eval_gettext 'Patch failed at $msgnum $FIRSTLINE'; echo
 803                stop_here_user_resolve $this
 804        fi
 805
 806        if test -x "$GIT_DIR"/hooks/pre-applypatch
 807        then
 808                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 809        fi
 810
 811        tree=$(git write-tree) &&
 812        commit=$(
 813                if test -n "$ignore_date"
 814                then
 815                        GIT_AUTHOR_DATE=
 816                fi
 817                parent=$(git rev-parse --verify -q HEAD) ||
 818                say >&2 "$(gettext "applying to an empty history")"
 819
 820                if test -n "$committer_date_is_author_date"
 821                then
 822                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 823                        export GIT_COMMITTER_DATE
 824                fi &&
 825                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 826        ) &&
 827        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 828        stop_here $this
 829
 830        if test -f "$dotest/original-commit"; then
 831                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 832        fi
 833
 834        if test -x "$GIT_DIR"/hooks/post-applypatch
 835        then
 836                "$GIT_DIR"/hooks/post-applypatch
 837        fi
 838
 839        go_next
 840done
 841
 842if test -s "$dotest"/rewritten; then
 843    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 844    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 845        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 846    fi
 847fi
 848
 849rm -fr "$dotest"
 850git gc --auto